
{$APPTYPE GUI}{$MODE DELPHI}

program Demo31;

uses
  SysUtils,windows,math,gl,glu,GraphOGL,GOGL_Collision;

//const
 
//type
  
//var 

  
//{$i *.inc} // se abilitato cosente di caricare i comandi che risiedono nei file INC
      
//{$R sound.rc}
//{$R sound.res} 
//{$R *.res}  
	
	
procedure Scena;
begin    
  PutTerrain(0);
end;
	
	
procedure Scena_;
begin    
  PutTerrain(1);
end;	
	
	
procedure Event1A; // scena intera
begin
  TextureSelectID(0);
   
  glEnable(GL_BLEND);    
  Scena;
  glDisable(GL_BLEND);  
end;


procedure Event1B;
begin
  TextureSelectID(0);
  FX_CutViewPlaneBegin(0,-3.25,0, 0,0,0,CUT_PLANE_DOWN);
      
  Scena;
end;
  
  
procedure Masck;
begin 
  PutTextureAnimation(31); 
  FX_CutViewPlaneBegin(0,-3.25,0, 0,0,0,CUT_PLANE_UP);
 
  Scena_; 
end;


procedure OpenGL_CreateList();

procedure OpenGL_Texture();
begin  
  
  SetTextureAnimation('Anim\WaterRef',31);	
  TextureLoadID('palude1.bmp',0);  
  TextureWater('cosmo1.bmp',0);
 
end;
begin 

  OpenGL_Texture();	  	    
  
  LoadTerrain(0,0-0.8,0, 10,0, 'palude.ter',true,0);
  LoadTerrain2(0,0-0.8,0, 10,0, 10,'palude.ter',true,1);
  
end;


procedure OpenGL_Draw();

procedure OpenGL_Draw2D();
begin
 
  OpenGL_I2D(0,0,0,0);               // inizializza la grafica 2D 
  
  SetPosXY(0,0);                     // consente di corregge lo zero della grafica 2D   
   
  
  OpenGL_Init(500,0,0,0,0);  // reimposta la grafica 3D
  
end;
procedure OpenGL_Mouse2D();
begin
  
end;
procedure OpenGL_Keyboard();
begin
 
end;
begin

  glClear(GL_COLOR_BUFFER_BIT OR GL_DEPTH_BUFFER_BIT);
  glLoadIdentity();
 
  OpenGL_Draw2D();               // carica gli elementi per la grafica 2d 
  OpenGL_Mouse2D();              // carica i comandi del mause per la grafica 2d
  OpenGL_Keyboard();             // carica i comandi della tastiera
  
  glTranslatef(0,0,-40);        // regola l'inquadratura degli elementi nello schermo
  glRotatef(25,1,0,0);
  SetglMouseMove(GL_M0,2);
  glRotatef(45,0,1,0);            // regola l'inquadratura di n gradi rispetto agli assi x y z      
  
  PutglPointLight(GL_LIGHT0,0,0,25,0,0.1);     

  FX_Mixer(Event1A,Masck,procnull);
  FX_Mixer(Event1B,procnull,procnull);  
   
  SetglSprite(false);    
  EffectRealWater;
  //SetglMatWater(10); 
  glTranslatef(0,-3.1,0);
  glScalef(4.25,4.25,4.25);  
  glRotatef(180,1,0,0);
  CreateWater(63,0,0,0,3,3,5,0.96,true,false,0);
  EffectRealWaterOFF;
  SetglSpriteOFF;    
  
end;

// inizio del programma
begin

 if MessageBox(0,'Settare lo schermo intero?  ', 'Video!',MB_YESNO OR MB_ICONQUESTION) = IDNO 
  then fullscreen := false else fullscreen := true;
  
 OGLWindowSetting(ARROW,'',GENERIC,'');
 CreateOGLWindow('Texture animata', 800, 600, 32, fullscreen);// si possono usare anche dei rapporti diversi da 4/3 o 16/9
 OpenGL_Init(500,0,0,0,0);			  // inizializza la grafica OpenGL(consente d'impostare il colore di sfondo e la profondit della visuale) 
 SetglRefractive();                         // imposta la rifrazione ambientale ed elimina le facce interne
 SetglLight(GL_LIGHT0,0.0,0.0,0.0,0.1);     // imposta la luce ambientale
 OpenGL_CreateList();                       // carica le liste degli oggetti (modelli composti)

 // impostare qui i valori delle variabili   

 REPEAT				     // inizio del ciclo principale

 glCLEAR(GL_COLOR_BUFFER_BIT);
 Setglmsg();

 OpenGL_Draw();             // carica gli elementi che devono essere un aggiornati sullo schermo 
 SwapBuffers(dcWindow);	    // abilita la visualizzazione grafica OpenGL

 // inserire qui eventuali dati aggiuntivi

UNTIL active = false;		// fine del ciclo principale (premere ESC per uscire)

 DeleteOGLWindow();		    // chiude la finestra
end.
